package
{
	import flash.events.DataEvent;
	import flash.events.MouseEvent;
	import flash.external.ExternalInterface;
	import flash.net.URLRequest;
	import flash.net.XMLSocket;
	
	import org.flixel.*;
	
	public class GameState extends FlxState
	{
		[Embed(source="data/bg.png")] public static var ImgBG:Class;
		[Embed(source="data/phone.png")] public static var ImgPhone:Class;
		[Embed(source="data/walker.png")] public static var ImgPlayer:Class;
		[Embed(source="data/ring.mp3")] public static var SndRing:Class;
		[Embed(source="data/ringmute.mp3")] public static var SndRingMute:Class;
		[Embed(source="data/pickup.mp3")] public static var SndPickup:Class;
		
		public var local:Boolean;
		public var bg:FlxSprite;
		public var p:FlxSprite;
		public var phone:FlxSprite;
		public var greeting:FlxText;
		public var position:int;
		public var state:String;
		public var id:String;
		
		public function scaleSpr(s:FlxSprite,n:Number):void
		{	
			s.scale=new FlxPoint(n,n);
			s.x-=s.width/2;
			s.y-=s.height/2;
			s.width=n*s.width;
			s.height=n*s.height;
			s.x+=s.width/2;
			s.y+=s.height/2;
		}
		
		public var posarray:Array = [2,13,20]; 
		
		private function readParameters():String
		{
			var params:String =
				
				ExternalInterface.call("window.location.search.substring");
			return (params?params.substring(4):null);
		}
		
		override public function create():void
		{	
			local=false;
			t=-10;
			u=-10;
			position=2;
			ringing=false;
			donestuff=false;
			
			super.create();
			bgColor = 0xFFFFFFFF;
			bg = new FlxSprite(0,0);
			bg.loadGraphic(ImgBG,true,false,29,20);
			bg.addAnimation("default",[0]);
			bg.addAnimation("onPhone",[1],0.2,false);
			bg.addAnimation("phonedown",[2],0.2,false);
			bg.play("default");
			scaleSpr(bg,27);
			add(bg);
			
			phone = new FlxSprite(10*27,6*27);
			phone.loadGraphic(ImgPhone,true,false,5,6);
			phone.addAnimation("default",[0]);
			phone.addAnimation("ring",[0,1],5);
			scaleSpr(phone,27);
			add(phone);									
			
			p = new FlxSprite(20*27,2*27);
			p.loadGraphic(ImgPlayer,true,false,5,17);
			p.addAnimation("0",[0]);
			p.addAnimation("1",[1]);
			p.addAnimation("2",[0]);			
			scaleSpr(p,27);
			add(p);			
			
			greeting = new FlxText(0,FlxG.height*3./4,FlxG.width);
			greeting.size=64;
			greeting.alignment="center";		
			greeting.color=0xffff0000;
			add(greeting); 
			
			//ringring();
			
			
			TitleState.xmlSocket.addEventListener(DataEvent.DATA, onIncomingData);
			
			this.sendtext("imissyou");
			FlxG.log("sent game name");
			
			this.id=readParameters();
			
			if (this.id==null)
			{	
				state="initializing";
				this.sendtext("principal");				
			}
			else
			{
				this.sendtext(this.id);
				FlxG.log(this.id);		
				state="precall";
				this.greeting.text="[space to call]";
			}
			
			
		}
		
		public function ringring():void
		{
			phone.play("ring");
			FlxG.playMusic(SndRing);
			this.greeting.text="[space to pick up]";
			ringing=true;
		}
		
		public function sendtext(s:String):void
		{
			if (TitleState.xmlSocket.connected)
				TitleState.xmlSocket.send(s);
			else
				FlxG.state = new ErrorState("disconnected");
		}
		
		public function disconnect():void
		{
			TitleState.xmlSocket.close();
		}
		
		
		public function onIncomingData(event:DataEvent):void
		{
			
			FlxG.log(event.data);
			if (event.data.split(":")[0]=="ERROR")
			{
				FlxG.state= new ErrorState("server error " + event.data.split(":")[1]);				
				return;
			}
			if (event.data=="LOCAL")
			{
				this.local=true;
				return;
			}
			switch (state)
			{
				case "initializing":
					this.id=event.data;
					//var base:String = "http://ded.increpare.com/~locus/imissyou/index.html"
					var base:String = ExternalInterface.call('window.location.href.toString');
					var myurl:String = base + "?id="+this.id;
					ExternalInterface.call("setURL",myurl);		
					state="waiting";
					break;
				case "waiting":
					if (event.data=="ring")
					{
						state="ringing";
						ExternalInterface.call("setText","");		
						ringring();
					}
					break;
				case "pickingup":
					if (event.data=="connect")
					{
						p.visible=false;
						phone.visible=false;
						bg.play("onPhone");
						FlxG.play(SndPickup);
						FlxG.music.stop();
						t=4;
					}
					break;
				case "call":
					if (event.data=="connect")
					{
						p.visible=false;
						phone.visible=false;
						bg.play("onPhone");
						FlxG.music.stop();
						u=4;
					}
					break;					
				default:			
					trace("[" + event.type + "] " + event.data);
					FlxG.log(event.data);
					break;
			}
		}
		
		public var t:Number;
		public var u:Number;
		
		public var ringing:Boolean;
		public var donestuff:Boolean;
		override public function update():void
		{			
			if (donestuff)
			{
				super.update();
				return;
			}
			
			if (t>=0)
			{
				t-=FlxG.elapsed;
				
				if (t<=0)
				{
					greeting.text="";
					bg.play("phonedown");
					donestuff=true;
				}
				else if (t<2)
				{					
					greeting.text= this.local ? "aaah!" : "I love you too";	
				}
				
			}
			
			if (u>=0)
			{
				u-=FlxG.elapsed;
				
				if (u<=0)
				{
					greeting.text="";
					bg.play("phonedown");
					donestuff=true;
				}
				else if (u<2)
				{					
					greeting.text="";	
				}
				else
				{
					greeting.text= this.local ? "I'm in your house..." : "I love you so much.";						
				}
				
			}
			
			if (FlxG.keys.justPressed("LEFT"))
			{
				if (position>0) position--;	
				updatepos();	
			}
			if (FlxG.keys.justPressed("RIGHT"))
			{
				if (position<2) position++;
				updatepos();
			}
			if (state=="ringing" && FlxG.keys.justPressed("SPACE"))
			{
				greeting.text="";
				this.sendtext("pickup");
				state="pickingup";
			}
			if (state=="precall" && FlxG.keys.justPressed("SPACE"))
			{
				state="call";
				this.sendtext("call");
				p.visible=false;
				phone.visible=false;
				greeting.text="";
				FlxG.play(SndPickup);
				FlxG.playMusic(SndRingMute);
				bg.play("onPhone");
				
			}
			super.update();
		}
		
		public function updatepos():void
		{
			p.x=60+27*posarray[position];
			p.play(position.toString());
		}
	}
}